function[G,h_iu,h_ie,h_ue,h_au,h_ae] =GenChannel(N,M)
%%  Weighted Sum-Rate Maximization for Reconfigurable Intelligent Surface Aided Wireless Networks 
lamda=3*1e8/(2.4*1e9);  %wave_length
C0=(lamda/(4*pi))^2;          %%%% 
d0=1;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% kappa_ai=-2;kappa_au=-2.2;kappa_ae=-2.2; 
% kappa_ue=-2;kappa_iu=-2;kappa_ie=-2;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

kappa_ai=-2.2;kappa_au=-2.2;kappa_ae=-2.2; 
kappa_ue=-2.2;kappa_iu=-2;kappa_ie=-2;
xy_ap=[0,0];
xy_irs=[15,20];
xy_ue=[30,0];
xy_eve=[40,7.5];

% xy_ap=[0,0];
% xy_irs=[30,40];
% xy_ue=[60,0];
% xy_eve=[80,15];
d_ue=norm(xy_eve-xy_ue);
d_iu=norm(xy_irs-xy_ue);
d_ie=norm(xy_irs-xy_eve);
d_ai=norm(xy_ap-xy_irs);
d_au=norm(xy_ap-xy_ue);
d_ae=norm(xy_ap-xy_eve);

eps1=10;                    %˹˥
eb1=sqrt(eps1/(1+eps1));    % sqrt(a/(1+a)) a=10
eb2=sqrt(1/(1+eps1));       % sqrt(1/(1+a)) a=10
User_angle=rand(1);  
Eve_angle=rand(1);
AP_angle=rand(1); 
IRS_angle=rand(1);

G=channel_G(AP_angle,IRS_angle,eb1,eb2,N,M);    %Losŵ

h_iu=channel_Hr(User_angle,eb1,eb2,N);           %Losŵ
h_iu=sqrt(C0*(d_iu/d0)^(kappa_iu))*h_iu;
h_ie=channel_Hr(Eve_angle,eb1,eb2,N);            %Losŵ
h_ie=sqrt(C0*(d_ie/d0)^(kappa_ie))*h_ie;

h_au=eb2*normrnd(0,1,1,M)+1j*normrnd(0,1,1,M);           %NLos
h_au=sqrt(C0*(d_au/d0)^(kappa_au))*h_au;

h_ae=eb2*normrnd(0,1,1,M)+1j*normrnd(0,1,1,M);           %NLos
h_ae=sqrt(C0*(d_ae/d0)^(kappa_ae))*h_ae;

h_ue=sqrt(1/2)*(eb1*(normrnd(0,1,1,1)+1j*normrnd(0,1,1,1))+eb2*(normrnd(0,1,1,1)+1j*normrnd(0,1,1,1)));
h_iu=h_iu.';
h_ie=h_ie.';
h_au=h_au.';
h_ae=h_ae.';
end