function [Theta]=OptConTheta(N,W,G,rho,h_iu,h_ie,h_ue,h_au,h_ae,var_si,var_u,var_e,var_id,var_an,a,b,Em,w)

%%  ʼ
var_au=var_si+var_u+var_id/rho;
var_ae=var_e+var_an*(abs(h_ue))^2;
H_u=1/var_au*[diag(h_iu')*G*w*w'*G'*diag(h_iu')',diag(h_iu')*G*w*w'*h_au;
    h_au'*w*w'*G'*diag(h_iu')',0];
H_e=1/var_ae*[diag(h_ie')*G*w*w'*G'*diag(h_ie')',diag(h_ie')*G*w*w'*h_ae;
    h_ae'*w*w'*G'*diag(h_ie')',0];
g_u=abs(h_au'*w*w'*h_au/var_au);
g_e=abs(h_ae'*w*w'*h_ae/var_ae);

%%  Ż

cvx_begin quiet
variable Q(N+1,N+1) hermitian
variable tau1
maximize(real(trace(H_u*Q))+tau1*(1+g_u))
subject to
%tau1*(b-1/a*log(Em/(var_an+P_cir)-1))
0<=(1-rho)*var_au*(real(trace(H_u*Q)));
real(trace(H_e*Q))+tau1*(g_e+1)<=1;
for i=1:N+1
    E=zeros(N+1,N+1);
    E(i,i)=1;
real(trace(E*Q))<=tau1;
real(trace(E*Q))>=tau1;
end
Q==hermitian_semidefinite(N+1);
tau1>=0;
cvx_end

 Q1=Q/tau1;




% if rank(Q1)==1
%     
%      Theta=MySVD(Q1);
% %     [S,D]=eig(X);
% %     Val=[];
% %     for i=1:N
% %         Val(i)=D(i,i);
% %     end
% %     [~,Index]=sort(Val,'descend');%index1ʾֵӦλ  ݴλSѰ
% %     Theta=S(:,Index(1));
% else
    %% ˹
    random=1000;
    mu2=zeros(1,N+1);
    for n=1:random
        xn=mvnrnd(mu2,Q1)';  %random  Ŀ꺯
        XN=xn*xn';
        Fun1(n)=real(norm(XN-Q1,'fro'));
        Theta_set(:,n)=xn;
    end
    [~,index]=min(Fun1);
    Theta=Theta_set(1:N,index);%յõAFȨ
%end

end